# To the extent possible under law, Eric Muller has waived all
# copyright and related or neighboring rights to the efele.net/tz maps
# (comprising the shapefiles, the web pages describing them and the scripts
# and data used to build them. This work is published from the United States of
# America.
#
# See http://creativecommons.org/publicdomain/zero/1.0/ for more details.


shp2pgsql -s 4326 -S -d -g geom -i -I countyp020_fixed countyp020_fixed | \
   psql -q -L county.log

shp2pgsql -s 4326 -S -d -g geom -i -I timeznp020_fixed timeznp020_fixed | \
   psql -q -L timezn.log

psql.exe <<EOF

---- overlay countyp020_fixed and timeznp020_fixed

SELECT DropGeometryColumn('','tz_us_overlay','geom');
DROP table tz_us_overlay;
CREATE TABLE tz_us_overlay (state text, county text, symbol text, tzid  text);
SELECT AddGeometryColumn('','tz_us_overlay','geom','4326','GEOMETRY',2);


INSERT INTO tz_us_overlay (geom, state, county, symbol)
SELECT geom (ST_dump (ST_intersection (countyp020_fixed.geom, timeznp020_fixed.geom))),
       countyp020_fixed.state, 
       countyp020_fixed.county, 
       timeznp020_fixed.symbol
FROM countyp020_fixed, timeznp020_fixed
WHERE ST_intersects (countyp020_fixed.geom, timeznp020_fixed.geom);

---- retain only the polygons

SELECT DropGeometryColumn('','tz_us_overlaya','geom');
DROP table tz_us_overlaya;

CREATE TABLE tz_us_overlaya (state text, county text, symbol text, tzid text);
SELECT AddGeometryColumn('','tz_us_overlaya','geom','4326','POLYGON', 2);

INSERT INTO tz_us_overlaya (geom, state, county, symbol)
SELECT geom, state, county, symbol
FROM tz_us_overlay
WHERE GeometryType (geom) = 'POLYGON';

---- tzid is unknown at this point

UPDATE tz_us_overlaya SET tzid = 'unknown';

---- assign tzid

UPDATE tz_us_overlaya SET tzid = 'America/Boise'
WHERE (state = 'ID' OR state = 'OR')
  AND symbol = 'MO';

UPDATE tz_us_overlaya SET tzid = 'America/Phoenix'
WHERE symbol = 'MOno';

UPDATE tz_us_overlaya SET tzid = 'America/Denver'
WHERE symbol = 'MO'
  AND tzid = 'unknown';

UPDATE tz_us_overlaya SET tzid = 'America/North_Dakota/Center'
WHERE state = 'ND' 
  AND county = 'Oliver County';

UPDATE tz_us_overlaya SET tzid = 'America/North_Dakota/New_Salem'
WHERE state = 'ND'
  AND county = 'Morton County';

UPDATE tz_us_overlaya SET tzid = 'America/North_Dakota/Beulah'
WHERE state = 'ND'
  AND county = 'Mercer County';

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Marengo'
WHERE state = 'IN' 
  AND county = 'Crawford County';

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Vincennes'
WHERE state = 'IN'
  AND (   county = 'Daviess County'
       OR county = 'Dubois County'
       OR county = 'Knox County'
       OR county = 'Martin County');

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Tell_City'
WHERE state = 'IN'
  AND (   county = 'Perry County');

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Petersburg'
WHERE state = 'IN'
  AND (   county = 'Pike County');

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Knox'
WHERE state = 'IN'
  AND (   county = 'Starke County');

UPDATE tz_us_overlaya SET tzid =  'America/Indiana/Winamac'
WHERE state = 'IN'
  AND (   county = 'Pulaski County');

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Vevay'
WHERE state = 'IN'
  AND (   county = 'Switzerland County');

UPDATE tz_us_overlaya SET tzid = 'America/Kentucky/Louisville'
WHERE state = 'IN'
  AND (   county = 'Clark County'
       OR county = 'Floyd County'
       OR county = 'Harrison County');

UPDATE tz_us_overlaya SET tzid = 'America/Kentucky/Louisville'
WHERE state = 'KY'
  AND (   county = 'Jefferson County');

UPDATE tz_us_overlaya SET tzid = 'America/New_York'
WHERE state = 'IN'
  AND (   county = 'Dearborn County'
       OR county = 'Ohio County');

UPDATE tz_us_overlaya SET tzid = 'America/Chicago'
WHERE state = 'IN'
  AND (   county = 'Gibson County'
       OR county = 'Jasper County'
       OR county = 'Lake County'
       OR county = 'LaPorte County'
       OR county = 'Newton County'
       OR county = 'Porter County'
       OR county = 'Posey County'
       OR county = 'Spencer County'
       OR county = 'Vanderburgh County'
       OR county = 'Warrick County'
       OR county is null);  -- area in great lake

UPDATE tz_us_overlaya SET tzid = 'America/Indiana/Indianapolis'
WHERE state = 'IN' 
  AND tzid = 'unknown';

UPDATE tz_us_overlaya SET tzid = 'America/Kentucky/Monticello'
WHERE state = 'KY'
  AND (   county = 'Wayne County');

UPDATE tz_us_overlaya SET tzid = 'America/Menominee'
WHERE state = 'MI'
  AND (   county = 'Dickinson County'
       OR county = 'Gogebic County'
       OR county = 'Iron County'
       OR county = 'Menominee County');


UPDATE tz_us_overlaya SET tzid = 'America/Detroit'
WHERE state = 'MI'
  AND tzid = 'unknown';

UPDATE tz_us_overlaya SET tzid = 'America/Chicago'
WHERE symbol = 'CE'
  AND tzid = 'unknown';

UPDATE tz_us_overlaya SET tzid = 'America/Los_Angeles'
WHERE symbol = 'PA'
  AND tzid = 'unknown';

UPDATE tz_us_overlaya SET tzid = 'America/New_York'
WHERE symbol = 'EA'
  AND tzid = 'unknown';

--- Hawaii

UPDATE tz_us_overlaya SET tzid = 'Pacific/Honolulu'
WHERE symbol = 'HAno';

--- Puerto Rico

UPDATE tz_us_overlaya SET tzid = 'America/Puerto_Rico'
WHERE state = 'PR';

--- Virgin Islands

UPDATE tz_us_overlaya SET tzid = 'America/St_Thomas'
WHERE state = 'VI';

--- Alaska

UPDATE tz_us_overlaya SET tzid = 'America/Adak'
WHERE state = 'AK'
  AND symbol = 'HA';

UPDATE tz_us_overlaya SET tzid = 'America/Yakutat'
WHERE state = 'AK'
  AND (   county = 'Yakutat City and Borough');

UPDATE tz_us_overlaya SET tzid = 'America/Juneau'
WHERE state = 'AK'
  AND (   county = 'Skagway-Hoonah-Angoon Census Area'
       OR county = 'Juneau City and Borough'
       OR county = 'Haines Borough');


UPDATE tz_us_overlaya SET tzid = 'America/Sitka'
WHERE state = 'AK'
  AND (   county = 'Wrangell-Petersburg Census Area'
       OR county = 'Sitka City and Borough'
       OR county = 'Prince of Wales-Outer Ketchikan Census Area'
       OR county = 'Ketchikan Gateway Borough'
       OR county is null);   -- boundary with canada at the south, in a river

UPDATE tz_us_overlaya SET tzid = 'America/Metlakatla'
WHERE tzid = 'America/Sitka'
  AND ST_Intersects (geom, ST_PolygonFromText ('POLYGON ((-131.57693311313548 55.295894430684484, -131.64983112999735 55.22111112028309, -131.67622523955077 54.99047687728049, -131.57064880133706 54.984192565482054, -131.55329680330033 55.0128590969046, -131.49963607801473 55.00493079441689, -131.40788512575756 54.98733472138127, -131.33310181535617 55.02189843627267, -131.3048224122632 55.19408857954982, -131.40474296985835 55.22488170736216, -131.46507236312334 55.25064738573574, -131.50089294037443 55.280812082368236, -131.54488312296345 55.287724825346515, -131.57693311313548 55.295894430684484))', 4326));



SELECT DropGeometryColumn('','temp_alaska','geom');
DROP table temp_alaska;

CREATE TABLE temp_alaska (state text, county text, symbol text, tzid text);
SELECT AddGeometryColumn ('','temp_alaska','geom','4326','POLYGON', 2);

INSERT INTO temp_alaska (geom, state, county, symbol, tzid)
SELECT geom (ST_dump (ST_intersection (geom, 
                                       ST_PolygonFromText ('POLYGON((-180 80, 
                                                         -162 80,
                                                         -162 50, 
                                                         -180 50, 
                                                         -180 80))', 4326)))),
       state, 
       county, 
       symbol,
       'America/Nome'
FROM tz_us_overlaya
WHERE state = 'AK'
  AND tzid = 'unknown';


INSERT INTO temp_alaska (geom, state, county, symbol, tzid)
SELECT geom (ST_Dump (ST_intersection (geom, 
                                       ST_PolygonFromText ('POLYGON((-100 80, 
                                                                     -162 80,
                                                                     -162 50, 
                                                                     -100 50, 
                                                                     -100 80))', 4326)))),
       state, 
       county, 
       symbol,
       'America/Anchorage'
FROM tz_us_overlaya
WHERE state = 'AK'
  AND tzid = 'unknown';


DELETE FROM tz_us_overlaya
WHERE state = 'AK'
  AND tzid = 'unknown';

INSERT INTO tz_us_overlaya (geom, state, county, symbol, tzid)
SELECT geom, state, county, symbol, tzid
FROM temp_alaska
WHERE GeometryType (geom) = 'POLYGON';


--- dissolve on the tzid attribute

SELECT DropGeometryColumn ('', 'tz_us', 'geom');
DROP table tz_us;

CREATE TABLE tz_us (tzid text);
SELECT AddGeometryColumn ('', 'tz_us', 'geom', 4326, 'POLYGON', 2);

INSERT INTO tz_us (tzid, geom)
  SELECT tzid, geom FROM (
    SELECT tzid, (ST_Dump (geom)).geom AS geom FROM (
      SELECT tzid, ST_union (geom) AS geom
      FROM tz_us_overlaya
      GROUP BY tzid)
    as x)
  as y;

--- clean up
SELECT DropGeometryColumn('','tz_us_overlay','geom');
DROP table tz_us_overlay;


SELECT DropGeometryColumn('','tz_us_overlaya','geom');
DROP table tz_us_overlaya;


EOF

pgsql2shp -g geom -f tz_us geo tz_us

